// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITreeSelect;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Makes a tree node selectable.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeSelectTagDeclaration}.
 */
public class UITreeSelect
    extends AbstractUITreeSelect implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TreeSelect";

  public static final String COMPONENT_FAMILY = "javax.faces.SelectBoolean";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    markup,
    label,
    showCheckbox,
    tip,
    disabled,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Text value to display as label. If text contains an underscore the next character is used as accesskey (if
   configured so and possible).

  */
  public java.lang.String getLabel() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.label);
  }

  public void setLabel(java.lang.String label) {
    getStateHelper().put(PropertyKeys.label, label);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Show a checkbox to visualize the selection state. This is useful to hide the checkbox, e. g. dependent of the type
   of the node.
  <br />Default: <code>true</code>
  */
  public boolean isShowCheckbox() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showCheckbox);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowCheckbox(boolean showCheckbox) {
    getStateHelper().put(PropertyKeys.showCheckbox, showCheckbox);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.disabled);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    getStateHelper().put(PropertyKeys.disabled, disabled);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}